import i from "axios";
import { message as u } from "ant-design-vue";
import { saveAs as l } from "file-saver";
const c = {
  LOGIN: "oauth/token",
  REGISTER: "user/register",
  RESET: "user/reset",
  LOGOUT: "oauth/logout"
}, R = {
  IMAGE_CODE: "sms/getImgCode",
  SMS_REGISTER: "sms/register",
  SMS_RESET: "sms/reset"
}, O = {
  DELETE: (e) => `attachment/${e}`,
  STS_URL: "sts/getTempToken"
}, f = {
  RESOURCE_LIST: "resource",
  RULE_LIST: (e) => `resource/${e}/rule`,
  ADD_RULE: (e) => `resource/${e}/rule`,
  MODIFY_RULE: (e) => `resource/${e}/rule`,
  DELETE_RULE: (e) => `resource/rule/${e}`
}, w = {
  TREE_LIST: "menu/tree",
  ADD_MENU: "menu",
  UPDATE_MENU: (e) => `menu/${e}`,
  DELETE_MENU: (e) => `menu/${e}`
}, g = {
  LIST: "user",
  ADD_USER: "user",
  MODIFY_USER: (e) => `user/${e}`,
  SUSPEND_USER: (e) => `user/${e}/disable`,
  RESUME_USER: (e) => `user/${e}/enable`,
  DELETE_USER: (e) => `user/${e}`,
  // md5格式
  RESET_PASSWORD: "user/admin/resetPasswordMd5",
  // 普通格式
  // RESET_PASSWORD: "user/admin/resetPassword",
  OPERATIONS_URL: "login/search"
  // 用户运维列表
}, C = {
  LIST: "role",
  ADD: "role",
  MODIFY: (e) => `role/${e}`,
  DELETE: (e) => `role/${e}`,
  USER_LIST: (e) => `role/${e}/user`,
  BIND_USER: (e) => `role/${e}/user/bind`,
  UNBIND_USER: (e) => `role/${e}/user/unbind`,
  RESOURCES_LIST: (e) => `role/${e}/resource`,
  AUTHORIZE_RESOURCE: (e) => `role/${e}/resource/bind`,
  REVOKE_RESOURCE: (e) => `role/${e}/resource/unbind`,
  MENU_TREE_LIST: "menu/self/tree",
  MENU_TREE_ROLE_LIST: (e) => `/menu/${e}/tree`,
  MENU_LIST: (e) => `role/${e}/menu`,
  AUTHORIZE_MENU: (e) => `role/${e}/menu/bind`,
  REVOKE_MENU: (e) => `role/${e}/menu/unbind`,
  RESOURCE_RULE_LIST: (e, r) => `role/${e}/resource/${r}/rules`,
  AUTHORIZE_RESOURCE_RULE: (e) => `role/${e}/resource/rule/bind`,
  REVOKE_RESOURCE_RULE: (e) => `role/${e}/resource/rule/unbind`,
  AUTHORIZE_MENU_RULE: (e) => `role/${e}/menu/rule/bind`,
  REVOKE_MENU_RULE: (e) => `role/${e}/menu/rule/unbind`,
  MENU_RULE_LIST: (e, r) => `role/${e}/menu/${r}/rules`,
  BIND_FORM: (e) => `role/${e}/table/bind`,
  UNBIND_FORM: (e) => `role/${e}/table/unbind`,
  ROLE_FORM_LIST: (e) => `role/${e}/table`,
  FORM_ROLE_LIST: (e) => `resource/table/${e}/role`,
  DATA_RULE_LIST: (e) => `role/${e}/rule`,
  BIND_DATA_RULE: (e) => `role/${e}/rule/bind`,
  UNBIND_DATA_RULE: (e) => `role/${e}/rule/unbind`,
  AUTH: (e) => `role/${e}/table/bind`,
  AUTH_REVOKE: (e) => `role/${e}/table/unbind`,
  AUTH_SEARCH: (e) => `resource/table/${e}/role`,
  AUTH_RESOURCE: (e) => `/role/${e}/resource`
}, M = {
  QUERY: (e) => `formDesign/${e}`,
  DEPLOY: "formDesign",
  UPDATE: (e) => `formDesign/${e}`,
  SEARCH: "formDesign",
  DELETE: (e) => `formDesign/${e}?cascade=true`,
  FORM_IMPORT: "/table/import",
  FORM_EXPORT: "/table/export",
  RESOURCE_LIST: (e) => `/resource/table/${e}/role`,
  RESOURCE_BIND: (e) => `/resource/table/${e}/role/bind`,
  RESOURCE_UNBIND: (e) => `/resource/table/${e}/role/unbind`
}, s = {
  ADD: (e) => `form/${e}`,
  SEARCH: (e) => `form/${e}/search`,
  JOIN_SEARCH: (e) => `form/${e}/joinSearch`,
  BATCH: (e) => `form/${e}/batch`,
  SEARCH_BY_ID: (e, r, t, o) => `form/${e}/${r}?resolveDic=${t}&resolveSubItems=${o}`,
  DELETE_BY_ID: (e, r) => `form/${e}/${r}`,
  SEARCH_STATE: (e, r, t) => `custom/form/${e}/${r}/log?field=${t}`,
  UPDATE_STATE: (e, r) => `custom/form/${e}/${r}/state`,
  BATCH_STATE: (e) => `custom/form/${e}/state/batchUpdate`,
  BATCH_STATE_FILTER: (e) => `custom/form/${e}/state/batchUpdateByFilter`,
  UPDATE: (e) => `form/${e}`,
  IMPORT: (e) => `form/${e}/import`,
  COUNT: (e) => `/form/${e}/aggregation`
}, N = {
  LIST: "dataRule",
  GET: (e) => `dataRule/${e}`,
  ADD: "dataRule",
  UPDATE: (e) => `dataRule/${e}`,
  DELETE: (e) => `dataRule/${e}`
}, _ = "mis-management", S = "mis-management", T = btoa(`${_}:${S}`), d = () => {
  localStorage.clear(), window.location.reload();
}, E = i.create({
  // baseURL: window.import_meta?.VITE_APP_AXIOS_BASE_URL,
  timeout: 5e4
  // headers: { 'Content-Type': 'application/json;charset=utf-8' }
});
E.interceptors.request.use(
  (e) => {
    const { url: r } = e, t = r.split("?")[0];
    return [c.LOGIN].includes(t) ? e.headers.Authorization = `Basic ${T}` : [
      c.REGISTER,
      c.RESET,
      R.IMAGE_CODE,
      R.SMS_REGISTER,
      R.SMS_RESET
    ].includes(t) || (e.headers.Authorization = `Bearer ${localStorage.getItem("access_token")}`), e;
  },
  (e) => Promise.reject(e)
);
E.interceptors.response.use(
  (e) => {
    if (e.request.responseType === "blob")
      return e.data;
    const r = e.data, { code: t, msg: o, data: n } = r;
    return t === 2e3 ? Promise.resolve(n) : t === 4001 ? (u.error(o || "系统出错"), Promise.reject(new Error(o || "Error"))) : Promise.reject(e.data);
  },
  (e) => {
    let r = "";
    const t = e.response.status;
    switch (t) {
      case 400:
        r = "请求错误(400)";
        break;
      case 401:
        r = "登录过期，请重新登录！", d();
        break;
      case 403:
        r = "权限不足";
        break;
      case 404:
        r = "请求出错(404)";
        break;
      case 408:
        r = "请求超时(408)";
        break;
      case 500:
        r = "服务器错误(500)";
        break;
      case 501:
        r = "服务未实现(501)";
        break;
      case 502:
        r = "网络错误(502)";
        break;
      case 503:
        r = "服务不可用(503)";
        break;
      case 504:
        r = "网络超时(504)";
        break;
      case 505:
        r = "HTTP版本不受支持(505)";
        break;
      default:
        r = `连接出错(${e.response.status})!`;
    }
    return u.error(r), console.log("message :>> ", r), Promise.reject({ msg: r, states: t });
  }
);
const m = (e, r) => E.get(e, { params: r }), U = async (e, r) => await E.post(e, r), $ = async (e, r) => await E.delete(e, r), D = async (e, r) => await E.put(e, r), I = async (e, r) => await E.post(e, r, { responseType: "blob" }), A = async (e, r) => await E.get(e, { params: r, responseType: "blob" }), a = {
  // async get<T extends AxiosRequestConfig<any>, M>(url: string, params?: T): AxiosPromise<M> {
  //   return await service.get(url, { params })
  // },
  // async post<M, T = any>(url: string, data?: T): AxiosPromise<M> {
  //   return await service.post(url, data)
  // },
  // async put<T, M>(url: string, data: T): AxiosPromise<M> {
  //   return await service.put(url, data)
  // },
  // async postDownload(url, data) {
  //   return await service.post(url, data, { responseType: 'blob' })
  // },
  // async getDownload(url, params) {
  //   return await service.get(url, { params, responseType: 'blob' })
  // },
  get: m,
  post: U,
  delete: $,
  put: D,
  postDownload: I,
  getDownload: A
}, F = {
  /**
   * 表单数据查询接口
   * @param {*} formName 表名
   * @param {*} param 查询参数
   * @returns
   */
  async searchFormData(e, r) {
    return await a.post(s.SEARCH(e), r);
  },
  /**
   * 表单数据添加接口
   * @param {*} formName 表名
   * @param {*} formData 表单数据
   * @returns
   */
  async addFormData(e, r) {
    return await a.post(s.ADD(e), r);
  },
  /**
   * 表单数据批量添加接口
   * @param {*} formName 表名
   * @param {*} formData 表单数据
   * @returns
   */
  async batchAddFormData(e, r) {
    return await a.post(s.BATCH(e), r);
  },
  /**
   * 关联表单数据查询
   * @param {*} formName 表名
   * @param {*} param 查询参数
   * @returns
   */
  async joinSearchFormData(e, r) {
    return await a.post(s.JOIN_SEARCH(e), r);
  },
  /**
   * 表单数据查询单条
   * @param {*} formName 表名
   * @param {*} id 单条数据id
   * @param {*} resolveObj 是否翻译字典和显示子表
   * @returns
   */
  async searchFormDataById(e, r, t) {
    const o = (t == null ? void 0 : t.resolveDic) || !1, n = (t == null ? void 0 : t.resolveSubItems) || !1;
    return await a.get(s.SEARCH_BY_ID(e, r, o, n));
  },
  /**
   * 表单数据删除
   * @param {*} formName 表名
   * @param {*} id 单条数据id
   * @returns
   */
  async deleteFormDataById(e, r) {
    return await a.delete(s.DELETE_BY_ID(e, r));
  },
  /**
   * 表单数据批量删除
   * @param {*} formName 表名
   * @param {*} ids 数据id数组
   * @returns
   */
  async bathDeleteFormData(e, r) {
    return await a.delete(s.BATCH(e), {
      data: { dataIds: r }
    });
  },
  /**
   * 表单数据更新接口
   * @param {*} formName 表名
   * @param {*} id 单条数据id
   * @returns
   */
  async updateFormData(e, r) {
    return await a.put(s.UPDATE(e), r);
  },
  /**
   * 导入表单数据
   * @param {*} formName 表名
   * @param {*} file 导入文件
   * @returns
   */
  async importFormData(e, r) {
    const t = new FormData();
    return t.append("file", r), await a.post(s.IMPORT(e), t);
  },
  /**
   * 表单数据更新状态接口
   * @param {*} formName 表名
   * @param {*} dataId 单条数据id
   * @param {*} formData 参数
   * @returns
   */
  async updateState(e, r, t) {
    return await a.put(s.UPDATE_STATE(e, r), t);
  },
  /**
   * 表单数据批量修改状态
   * @param {*} formName 表名
   * @returns
   */
  async batchUpdateState(e, r) {
    return await a.post(s.BATCH_STATE(e), r);
  },
  /**
   * 表单数据根据过滤条件批量修改状态
   * @param {*} formName 表名
   * @returns
   */
  async filterBatchUpdateState(e, r) {
    return await a.post(s.BATCH_STATE_FILTER(e), r);
  },
  /**
   * 表单数据操作日志接口
   * @param {*} formName 表名
   * @param {*} dataId 单条数据id
   * @returns
   */
  async searchOperationLogs(e, r, t) {
    return await a.get(s.SEARCH_STATE(e, r, t));
  },
  /**
   * 表单数据统计
   * @param {*} formName 表名
   * @param {*} data
   * {
    "aggregates": [["农场类型", "count"]],
    "groupFields":["pcode"],
    "filter":["=", "农场类型", "种植"]
    }
   * @returns
   */
  async formDataCount(e, r) {
    return await a.post(s.COUNT(e), r);
  },
  /**
   * 表单数据下载
   * @param {string} name 文件名
   * @param {string} formName 表名称
   * @param {object} data 过滤条件
   */
  async dataDownload(e, r, t = {}) {
    return u.info(`开始下载：${e}`), a.postDownload(`form/${r}/download`, t).then((o) => {
      l(o, e);
    });
  },
  /**
   * 导入数据（附带额外信息）
   * @param {string} formName 表名称
   * @param {file} file 上传Excel表格   表头为label   重复label使用spareLabel
   * @param {object} data 自带数据    key值为name
   * @param {array} fieldAssemble  数组 需要拼接参数  多个sourcefields 以delimiter为连接符组装，然后赋值给targetField
   *  示例 {"sourceFields":["field1","field2"],"delimiter":"-","targetField":"field3"}
   */
  async formexImport(e, r, t, o) {
    const n = new FormData();
    return n.append("file", r), t && n.append("data", JSON.stringify(t)), o && n.append("fieldAssemble", JSON.stringify(o)), a.post(`/formex/${e}/import`, n);
  },
  /**
   * 表单word下载
   * @param {string} formName 表名称
   * @param {object} data 表单数据 {"dataId": "数据id", "subForms": [{ "formName": "物料使用情况表"}]}
   * @param {string} name  下载word名称
   */
  async downloadWord(e, r, t) {
    return t || (t = `${e}.docx`), u.info(`开始下载：${t}`), a.getDownload(`/extend/word/${e}/download`, r).then((o) => {
      l(o, t);
    });
  },
  /**
   * 表单pdf查看
   * @param {string} formName 表名称
   * @param {object} data 表单数据 {"dataId": "数据id", "subForms": [{ "formName": "物料使用情况表"}]}
   */
  viewPdfUrl(e, r) {
    const { dataId: t, subForms: o } = r;
    let n = `dataId=${t}`;
    return o && (n += `&subForms=${encodeURIComponent(JSON.stringify(o))}`), `${window.import_meta.VITE_APP_AXIOS_BASE_URL}/extend/pdf/${e}/download?${n}`;
  }
};
export {
  N as D,
  O as F,
  c as L,
  w as M,
  f as R,
  R as S,
  g as U,
  M as a,
  C as b,
  F as f,
  d as l,
  E as s,
  a as x
};
